/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.haptic_forces;

import java.util.LinkedList;
import org.jogamp.vecmath.Vector3f;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.ILocalToVworldGetter;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.ILocalToVworldListener;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.ITrackerToVworldGetter;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.controller.HapticPointerController;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.devices.haptics.HapticException;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.devices.haptics.IHapticDevice;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.devices.haptics.IHapticListener;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.haptic_forces.forces.IForce;
import org.visnow.vn.lib.basic.viewers.HapticViewer3D.model.haptic_forces.forces.SafetyDamping;
import static org.apache.commons.math3.util.FastMath.*;

/**
 * Class responsible for managing ForceContext within one device.
 * <p/>
 * There is one such object per device (IHapticDevice) per HapticViewer, so one device can be
 * linked to several DeviceContexts (in different haptic viewers).
 * <p/>
 * @author Krzysztof Madejski <krzysztof@madejscy.pl> ICM, University of Warsaw
 * @author Łukasz Czerwiński <czerwinskilukasz1 [#] gmail.com>, ICM, University of Warsaw, 2013
 */
public final class DeviceContext implements IForceGetter
{

    /**
     * A list of force contexts created. Used for emergency switching of all forces.
     * Used in development - when haptic device starts acting in a dangerous way.
     */
    private static LinkedList<ForceContext> forceContexts = new LinkedList<ForceContext>();
    private ForceContext forceContext;
    private IHapticDevice device;
    //
    /**
     * Stores recently applied force (in device (tracker) coordinate system).
     */
    private Vector3f force = new Vector3f();
    //
    /**
     * Force scale factor. Applied to force BEFORE clamp.
     */
    private float forceScale = 1;
    //
    /**
     * Maximum force value that will be generated by the device.
     * If the force that is going to be set is greater, it will be scaled to have value of
     * forceClamp.
     */
    private float forceClamp = 2;
    //
    //
    static final org.apache.log4j.Logger LOGGER
        = org.apache.log4j.Logger.getLogger(new Throwable().getStackTrace()[0].getClassName());
    /**
     * Maximum force that the device can handle in a short period of time.
     * It can be far more than maximum continuous force (in Phantom: 6x more!), so use it with care
     * not to damage the device!
     */
    private final double maxAllowedExertableForce;
    private final Vector3f lastComputedForce = new Vector3f();
    private boolean lastForceClamped = false;
    private final IHapticListener hapticListener;
    private final ILocalToVworldGetter localToVworldGetter;

    /**
     * Constructor. To be used by {@link HapticPointerController}.
     * <p/>
     * @param device              Device to be wrapped in context
     * @param localToVworldGetter object that returns local-to-vworld transform
     */
    public DeviceContext(IHapticDevice device,
                         ILocalToVworldGetter localToVworldGetter) throws HapticException
    {
        this.device = device;
        forceContext = newForceContext(localToVworldGetter);
        this.localToVworldGetter = localToVworldGetter;
        localToVworldGetter.addLocalToVworldChangeListener(forceContext);

        // for Phantom device getDeviceNominalMaxContinuousForce() must be called AFTER creating Openhaptics' device context 
        //        (which is currently being created in ForceContext)
        //TODO LOW: maybe move getDeviceNominalMaxContinuousForce() to ForceContext?
        //        this.maxAllowedForce = device.getDeviceNominalMaxContinuousForce();
        this.maxAllowedExertableForce = device.getDeviceNominalMaxExertableForce();
        hapticListener = new VNHapticListener();
        device.addHapticListener(hapticListener);
    }

    public IHapticDevice getDevice()
    {
        return device;
    }

    /**
     * The only method in the whole source code that should call
     * <code>ForceContext</code>
     * and
     * <code>HLForceContext</code> constructors.
     * <p/>
     * @param localToVworldGetter object that returns an up-to-date local-to-vworld transform
     * <p>
     * @return If device in this <code>DeviceContext</code> is <code>IPhantom</code>, returns
     *         <code>LForceContext</code>, else returns <code>ForceContext</code>
     */
    private ForceContext newForceContext(ILocalToVworldGetter localToVworldGetter)
    {

        ForceContext fc = new ForceContext(this, localToVworldGetter);

        // add safety damping to each created ForceContext
        fc.addForce(new SafetyDamping());

        forceContexts.add(fc);
        return fc;
    }

    /**
     * Disabled all force contexts. Use in emergency, when having problems with a haptic device.
     * Bind to a big key on keyboard to press it quickly.
     */
    public static void emergencyDisableForces()
    {
        for (ForceContext f : forceContexts) {
            f.setEnabled(false);
        }
    }

    public ForceContext getForceContext()
    {
        return forceContext;
    }

    public ILocalToVworldListener getLocalToVWorldListener()
    {
        return getForceContext();
    }

    /**
     * To be used only by {@link HapticPointerController}.
     */
    public void setTrackerToVworld(ITrackerToVworldGetter sensorToVworld)
    {
        this.forceContext.setTrackerToVworld(sensorToVworld);
    }

    /**
     * Gets the maximum force output to be rendered. Values that are over this
     * level are clamped.
     *
     * @return max force
     */
    @Override
    public float getForceClamp()
    {
        return this.forceClamp;
    }

    /**
     * Sets the maximum force output to be rendered. Values that are over this
     * level are clamped.
     *
     * @param forceClamp max force that can be outputed
     */
    public void setForceClamp(float forceClamp)
    {
        this.forceClamp = forceClamp;
    }

    @Override
    public float getForceScale()
    {
        return this.forceScale;
    }

    /**
     * To be used only by {@link HapticPointerController}.
     */
    public void setForceScale(float forceScale)
    {
        this.forceScale = forceScale;
    }

    /**
     * Enable or disable force output.
     * <p/>
     * To be used only by {@link HapticPointerController}.
     *
     * @param enabled Force output status
     */
    public void setForceEnabled(boolean enabled)
    {
        forceContext.setEnabled(enabled);
    }

    /**
     * Returns last computed force - a force vector that was generated by a device (if force
     * output was enabled) or would be generated (if force output was disabled).
     * <p/>
     * The force is given in device (tracker) coordinate system.
     * <p/>
     * @param out_force output parameter - will be set to last computed force vector
     */
    @Override
    public void getLastComputedForce(Vector3f out_force)
    {
        synchronized (lastComputedForce) {
            out_force.set(lastComputedForce);
        }
    }

    @Override
    public boolean wasLastForceClamped()
    {
        return lastForceClamped;
    }

    @Override
    public boolean isForceOutputEnabled()
    {
        return forceContext.isEnabled();
    }

    @Override
    public boolean isForceOutputDataBlocked()
    {
        return forceContext.isDataBlocked();
    }

    @Override
    public boolean isForceOutputDragBlocked()
    {
        return forceContext.isDragBlocked();
    }

    /**
     * In {@link #callback()} forces are computed and set to the haptic device.
     */
    private class VNHapticListener implements IHapticListener
    {

        /**
         * Computes force (using {@link ForceContext#computeForce}) and sets it to the haptic
         * device.
         * The function is called in real-time (1000 times a second).
         */
        @Override
        public void callback()
        {
            if (forceContext == null ||
                forceContext.isDataBlocked() ||
                forceContext.isDragBlocked()) {
                force.set(IForce.ZERO_FORCE);
                lastForceClamped = false;
            } else {
                forceContext.computeForce(force);

                force.scale(forceScale);

                // limit force to forceClamp value
                float forceLength = force.length();
                double realForceClamp = min(forceClamp, maxAllowedExertableForce);
                if (forceLength > realForceClamp) {
                    lastForceClamped = true;
                    //                    LOGGER.info("Force " + force + " (value: " + force.length() + ") was clamped to the value: " + realForceClamp + " (software clamp: " + forceClamp + ", hardware clamp: " + maxAllowedExertableForce);
                    if (forceClamp == 0) {
                        force.set(IForce.ZERO_FORCE);
                    } else {
                        force.scale(forceClamp / forceLength); // scale it to the length = forceClamp
                    }
                } else {
                    lastForceClamped = false;
                }
            }
            // save computed force
            // the value is saved even when no force is sent to the device, because we would like to show 
            // value of the force in GUI even when force output is disabled.
            synchronized (lastComputedForce) {
                lastComputedForce.set(force);
            }

            if (!forceContext.isEnabled()) {
                force.set(IForce.ZERO_FORCE);
            }
            device.setForce(force);
        }
    }

    /**
     * To be used only by {@link HapticPointerController}.
     */
    public void close()
    {
        // remove computing forces
        device.removeHapticListener(hapticListener);
        localToVworldGetter.removeLocalToVworldChangeListener(forceContext);
        forceContext.close();
    }
}
